#ifndef DEF_STACK_OF_COVER
#define DEF_STACK_OF_COVER

#include <cstring>
#include <algorithm>
#include <string>
#include <fstream>
#include <math.h>
#include <iostream>
#include <sstream> 
#include <vector>
#include <stdio.h>
#include "Cover.h"

using namespace std;

typedef std::vector<Cover*> Alls_Cover; 
typedef std::vector< vector <int> > Alls_Sigma_1;
//typedef std::vector< vector <int> > Alls_Sigma_0; 

class Stack_Of_Cover {
	
	public:
	
		/// Attributs	
		Alls_Cover Covers_; // All cover
		Alls_Sigma_1 Sigmas_1_; // All sigma_1	
		//Alls_Sigma_0 Sigmas_0_; // All sigma_0
				
		/// Methodes
		void Emplier_Cover_Sigma_1_(Cover *C_, vector <int> sigma1); // Add a new pair of <cover/current sigma1>
		void Depiler_Cover_Sigma_1_(); // delete the pair <cover/sigma1> in the top of the stack
		bool Inlcus(vector <int> sigma_1_Current); // test if current sigma_1 is included on sigma_1 in the top of the stack
		bool Egaux(vector <int> sigma_1_Current); // test if current sigma_1 is equal to sigma_1 in the top of the stack
		vector <int> Diffrence_Sigma_1(vector <int> sigma_1_Current); // new items of sigma = current sigma_1 \ sigma_1 in the top of the stack
		//vector <int> Diffrence_Sigma_0(vector <int> sigma_0_Current); // new items of sigma = current sigma_0 \ sigma_0 in the top of the stack
};

#endif // DEF_STACK_OF_COVER
