export LD_LIBRARY_PATH=/usr/local/lib/

TIMEOUT="3600s"

make clean
make

#./main datafile minsup #items_cat #trans_cat lb_I ub_I lb_T ub_T

echo "start GC4CIM -> Arxiv"
time timeout 3600s ./main Datasets/Arxiv 0.5 3 3 2 2 2 2 > Results/Arxiv
echo "finish GC4CIM -> Arxiv"

echo "start GC4CIM -> zoo"
time timeout 3600s ./main Datasets/zoo 0.5 6 10 2 3 2 3 > Results/zoo1
time timeout 3600s ./main Datasets/zoo 0.5 6 10 3 4 3 4 > Results/zoo2
time timeout 3600s ./main Datasets/zoo 0.5 6 10 2 6 2 10 > Results/zoo3
time timeout 3600s ./main Datasets/zoo 0.5 9 10 2 9 2 10 > Results/zoo4
time timeout 3600s ./main Datasets/zoo 0.5 18 10 3 18 2 10 > Results/zoo5
time timeout 3600s ./main Datasets/zoo 0.5 6 20 2 6 5 20 > Results/zoo6
time timeout 3600s ./main Datasets/zoo 0.5 9 20 3 9 5 20 > Results/zoo7
echo "finish GC4CIM -> zoo"

echo "start GC4CIM -> tic-tac-toe"
time timeout 3600s ./main Datasets/tic-tac-toe 0.5 3 10 2 3 2 3 > Results/tic-tac-toe1
time timeout 3600s ./main Datasets/tic-tac-toe 0.5 3 10 2 3 2 10 > Results/tic-tac-toe2
time timeout 3600s ./main Datasets/tic-tac-toe 0.5 9 10 2 3 2 3 > Results/tic-tac-toe3
time timeout 3600s ./main Datasets/tic-tac-toe 0.5 9 10 2 9 2 10 > Results/tic-tac-toe4
time timeout 3600s ./main Datasets/tic-tac-toe 0.5 3 20 2 3 2 10 > Results/tic-tac-toe5
time timeout 3600s ./main Datasets/tic-tac-toe 0.5 9 20 2 3 2 20 > Results/tic-tac-toe6
echo "finish GC4CIM -> tic-tac-toe"

echo "start GC4CIM -> Mushroom"
time timeout 3600s ./main Datasets/mushroom 0.5 7 12 2 2 2 2 > Results/mushroom1
time timeout 3600s ./main Datasets/mushroom 0.5 7 12 2 3 2 3 > Results/mushroom2
time timeout 3600s ./main Datasets/mushroom 0.5 7 12 2 7 2 12 > Results/mushroom3
echo "finish GC4CIM -> Mushroom"

echo "start GC4CIM -> Chess"
time timeout 3600s ./main Datasets/chess 0.7 5 34 2 2 2 2 > Results/chess1
time timeout 3600s ./main Datasets/chess 0.7 5 34 2 3 2 3 > Results/chess2
time timeout 3600s ./main Datasets/chess 0.7 15 94 2 2 2 2 > Results/chess3
time timeout 3600s ./main Datasets/chess 0.7 5 34 3 3 5 5 > Results/chess4
echo "finish GC4CIM -> Chess"
